VERSION 4.00
Begin VB.Form frmCrc32 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Crc32"
   ClientHeight    =   1800
   ClientLeft      =   1530
   ClientTop       =   1995
   ClientWidth     =   6015
   Height          =   2205
   Left            =   1470
   LinkTopic       =   "Crc32"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1800
   ScaleWidth      =   6015
   ShowInTaskbar   =   0   'False
   Top             =   1650
   Width           =   6135
   Begin VB.ListBox lstLookup 
      Height          =   1230
      Left            =   120
      MultiSelect     =   2  'Extended
      Sorted          =   -1  'True
      TabIndex        =   0
      Top             =   120
      Width           =   5775
   End
   Begin VB.CommandButton cmdCompute 
      Caption         =   "&Ermitteln"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   1440
      Width           =   1095
   End
   Begin VB.Label Label2 
      Alignment       =   2  'Center
      BackStyle       =   0  'Transparent
      Caption         =   "Quelle : Peter Larsson -- peso@swipnet.se"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   1440
      Width           =   5775
   End
End
Attribute VB_Name = "frmCrc32"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit
Option Compare Text
Private Crc32Table(255) As Long

Public Function GetCrc32(ByVal Crc32 As Long) As Long
'Turn on error trapping
On Error Resume Next

'Set function to the current Crc32 value
GetCrc32 = Crc32 Xor &HFFFF

End Function

Public Function AddCrc32(ByVal sItem As String, ByVal lCrc32 As Long) As Long

'Declare following variables
Dim bCharValue As Byte, iCounter As Integer, lIndex As Long
Dim lAccValue As Long, lTableValue As Long

'Turn on error trapping
On Error Resume Next

'Iterate through the string that is to be checksum-computed
For iCounter = 1 To Len(sItem)

'Get ASCII value for the current character
    bCharValue = Asc(Mid$(sItem, iCounter, 1))

'Then again, check for signed value
    If lCrc32 < 0 Then
        lAccValue = lCrc32 - &H101
        lAccValue = lAccValue \ &H100
        lAccValue = lAccValue And &HFFFFFF
    Else
        lAccValue = lCrc32 \ &H100
    End If

'Now select the right adding value from the holdong table
    lIndex = lCrc32 And &HFF
    lIndex = lIndex Xor bCharValue
    lTableValue = Crc32Table(lIndex)

'Then mix new Crc32 value with previous accumulated Crc32 value
    lCrc32 = lAccValue Xor lTableValue

'Loop counter iCounter to the end
Next

'Set function value the the new Crc32 checksum
AddCrc32 = lCrc32

End Function


Public Function InitCrc32(ByVal Seed As Long, ByVal Precondition As Long) As Long

'Declare counter variable iBytes, counter variable iBits, value variables lCrc32 and lTempCrc32
Dim iBytes As Integer, iBits As Integer
Dim lCrc32 As Long, lTempCrc32 As Long

'Turn on error trapping
On Error Resume Next

'Iterate 256 times
For iBytes = 0 To 255

'Initiate lCrc32 to counter variable
    lCrc32 = iBytes

'Now iterate through each bit in counter byte
    For iBits = 0 To 7

'Since Long variable type in Visual Basic is signed, we have to check wether or not value is less than zero. Set lTempCrc32 to the temporary value
        If lCrc32 < 0 Then
            lTempCrc32 = lCrc32 - &H1
            lTempCrc32 = lTempCrc32 \ &H2
            lTempCrc32 = lTempCrc32 And &H7FFFFFFF
        Else
            lTempCrc32 = lCrc32 \ &H2
        End If

'Now check if temporary is less than zero and then mix Crc32 checksum with Seed value
        If (lCrc32 And &H1) <> 0 Then
            lCrc32 = lTempCrc32 Xor Seed
        Else
            lCrc32 = lTempCrc32
        End If

'Loop counter iBits to the end
    Next

'Put Crc32 checksum value in the holding array
    Crc32Table(iBytes) = lCrc32

'Loop counter iBytes to the end
Next

'After this is done, set function value to the precondition value
InitCrc32 = Precondition

End Function

Private Sub cmdCompute_Click()

Dim A As Long, B As Long
Dim Vorgabetext As String

'Hier Text modifizieren
Vorgabetext = "Meine Oma schneidet Speck"

On Error Resume Next
A = InitCrc32(&HEDB88320, &HFFFF)
B = AddCrc32(Vorgabetext, A)

lstLookup.AddItem Vorgabetext & " = " & Hex(GetCrc32(B))

End Sub

Private Sub Form_Load()

On Error Resume Next
Me.Move (Screen.Width - Me.Width) \ 2, (Screen.Height - Me.Height) \ 2

End Sub
Private Sub Form_Unload(Cancel As Integer)

On Error Resume Next
Set frmCrc32 = Nothing

End Sub

